module H_mod

  use sep
 
  implicit none
  integer, private                         :: stat
  integer, private                         :: j, jl, j1, j2, jlag, jlag1, jlag2
  integer, private                         :: n1, n2, nlag1, nlag2

  real, dimension(:,:),     allocatable, private :: temp1, temp2
  real, dimension(:,:,:,:), allocatable, private :: Hgn
  contains

  subroutine H_init(n1_in, n2_in, nlag1_in, nlag2_in)
    integer, intent(in)                   :: n1_in, n2_in
    integer, intent(in)                   :: nlag1_in, nlag2_in
    n1 = n1_in 
    n2 = n2_in 
    nlag1 = nlag1_in 
    nlag2 = nlag2_in 
    allocate(temp1(n1,n2),temp2(n1,n2))
    allocate(Hgn(n1,n2,-nlag1:nlag1,-nlag2:nlag2))
  end subroutine

  function H_lop(adj, add, model, data) result(stat)
    integer                               :: stat 
    logical, intent(in)                   :: adj, add 
    real, dimension(:)                    :: model, data
    call H_lop2(adj, add, model, data)
    stat=0
  end function

  subroutine H_lop2(adj, add, model, data)
    logical, intent(in)                   :: adj, add
    real, dimension(:)                    :: model
    real, dimension(:)                    :: data

   call sep_init() 

    if(adj) then
      if(.not. add) model = 0.
      temp2=reshape(model,(/n1,n2/))
      temp1=reshape(data,(/n1,n2/))
      call sep_read(Hgn,"hess")
      do jlag2 = -nlag2,nlag2
        do jlag1 = -nlag1,nlag1
          do j2 = 1,n2
            do j1 = 1,n1
              temp2(j1,j2)=temp2(j1,j2)+Hgn(j1,j2,jlag1,jlag2)*temp1(j1+jlag1,j2+jlag2)
            end do
          end do
        end do
      end do
      model=reshape(temp2,(/n1*n2/))
    else
      if(.not. add) data = 0.
      temp2=reshape(data,(/n1,n2/))
      temp1=reshape(model,(/n1,n2/))
      call sep_read(Hgn,"hess")
      do jlag2 = -nlag2,nlag2
        do jlag1 = -nlag1,nlag1
          do j2 = 1,n2
            do j1 = 1,n1
              temp2(j1+jlag1,j2+jlag2)=temp2(j1+jlag1,j2+jlag2)+Hgn(j1,j2,jlag1,jlag2)*temp1(j1,j2)
            end do
          end do
        end do
      end do
      data=reshape(temp2,(/n1*n2/))
    end if

  end subroutine

end module
