PROGRAM dotptest
!*** Implements the dot-product test using module dptest_mod ***
USE sep
USE nmo_mod
USE dptest_mod

IMPLICIT NONE

INTEGER            :: nz,ns,nt,nx,n_model,n_data

REAL               :: oz,dz,os,ds,ot,dt,ox,dx
REAL, DIMENSION(2) :: dot1,dot2

CALL sep_init()

CALL from_param("nz",nz)
CALL from_param("oz",oz)
CALL from_param("dz",dz)
CALL from_param("ns",ns)
CALL from_param("os",os)
CALL from_param("ds",ds)
CALL from_param("nt",nt)
CALL from_param("ot",ot)
CALL from_param("dt",dt)
CALL from_param("nx",nx)
CALL from_param("ox",ox)
CALL from_param("dx",dx)

CALL nmo_init(nz,oz,dz,ns,os,ds,nt,ot,dt,nx,ox,dx)

n_model = nz*ns
n_data = nt*nx

CALL dptest(nmo_op,n_model,n_data,dot1,dot2)


WRITE(0,*) dot1
WRITE(0,*) dot2

CALL to_history("dot1",dot1)
CALL to_history("dot2",dot2)

CALL sep_close()

END PROGRAM
