module firstder_mod

  implicit none

  integer, private                    :: n1, n2, nt, it
  real, private                       :: idt

  contains

  subroutine firstder_init(n1_in, n2_in, nt_in, dt_in)
    integer                      :: n1_in, n2_in, nt_in
    real                         :: dt_in
    n1 = n1_in
    n2 = n2_in
    nt = nt_in
    idt = 1./dt_in
  end subroutine

  function firstder_op(adj, add, model, data) result(stat)
    logical,intent(in) :: adj, add
    real,dimension(:)  :: model, data
    integer            :: stat
    call firstder_op2(adj, add, model, data)
    stat=0
  end function

  subroutine firstder_op2(adj, add, model, data)
    logical,intent(in)          :: adj, add 
    real, dimension(n1,n2,nt) :: model, data
    if(adj) then
      if(.not. add) model = 0.
      do it = 1,nt-1
        model(:,:,it+1) =  model(:,:,it+1) + data(:,:,it)*idt
        model(:,:,it)   =  model(:,:,it)   - data(:,:,it)*idt
      end do
    else
      if(.not. add) data = 0.
      do it = 1,nt-1
        data(:,:,it) = data(:,:,it) + (-model(:,:,it)+model(:,:,it+1))*idt
      end do
    end if
  end subroutine

end module
