module grad_mod

  implicit none

  integer, private              :: nt, n1, n2
!  real, private                 :: d1, d2

  contains

  subroutine grad_init(n1_in, n2_in, nt_in)!, d1_in, d2_in)
    integer                     :: n1_in, n2_in, nt_in
!    real                        :: d1_in, d2_in
    n1 = n1_in
    n2 = n2_in
    nt = nt_in
!    d1 = d1_in
!    d2 = d2_in
  end subroutine

  function grad_op(p, px, pz) result(stat)
    real,dimension(:)  :: p, px, pz
    integer            :: stat
    call grad_op2(p, px, pz)
    stat=0
  end function

  subroutine grad_op2(p, px, pz)
    real, dimension(n1,n2,nt) :: p, px, pz
    px = 0.
    pz = 0.
    call c_grad(p, px, pz)
  end subroutine

end module
