module grad1_mod
! gradient in one dimension
  use classutil
implicit none
  contains
  function grad1_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
!    call adjnull (adj,add,xx,yy )
    call grad1_lop2(adj,add,xx,yy )
    stat=0
  end function 
  subroutine grad1_lop2(adj,add,xx,yy)
    logical,intent(in) :: adj,add 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
    integer i
    if(adj) then
      if(.not. add) xx = 0. 
    else
      if(.not. add) yy = 0.
    end if
    do i= 1, size(xx)-1  
      if ( adj) then
        xx(i+1) = xx(i+1) + yy(i)           ! resembles equation (1.2)
        xx(i  ) = xx(i  ) - yy(i)
      else
        yy(i) = yy(i) + xx(i+1) - xx(i)           ! resembles equation (1.1)
      end if
    end do
  end subroutine 
  subroutine grad1_close()
  end subroutine 
end module 
