! lowcut filter operator module
module lowcut_mod

  implicit none
  integer, private :: n1, n2
  real, private    :: rho

  contains

  subroutine lowcut_init(n1_in, n2_in, rho_in)
    integer           :: n1_in, n2_in
    real              :: rho_in
    n1 = n1_in
    n2 = n2_in
    rho = rho_in
  end subroutine

  function lowcut_op(adj, add, model, data) result(stat)
    logical,intent(in) :: adj, add
    real,dimension(:)  :: model, data
    integer            :: stat
    call lowcut_op2(adj, add, model, data)
    stat=0
  end function

  subroutine lowcut_op2(adj, add, model, data)
    logical,intent(in)     :: adj, add 
    real, dimension(n1,n2) :: model, data
    real, dimension(n2,n1) :: model1, data1
    integer                :: i, j
    real                   :: temp

    if(adj) then
      data1 = transpose(data)
      ! Write adjoint in here
      if(.not. add) model1 = 0.      
      do j=1,n1
        temp = data1(n2,j)
        model1(n2,j) = model1(n2,j) + temp
!        do i=n1-1,1,-1
        do i=1,n2-1
          temp = data1(n2-i,j) - data1(n2-i+1,j) + rho*temp
          model1(n2-i,j) = model1(n2-i,j) + temp
        end do
      end do
      model = transpose(model1)
    else
      model1 = transpose(model)
      if(.not. add) data = 0.      
      do j=1,n1
        temp = model1(1,j)
        data1(1,j) = data1(1,j) + temp
        do i=2,n2
          temp = model1(i,j) - model1(i-1,j) + rho*temp
          data1(i,j) = data1(i,j) + temp
        end do
      end do
      data = transpose(data1)
    end if
  end subroutine

end module
