module tconv_mod

  implicit none
    integer,private ::  nm, nd, nbc
    real, allocatable, private:: bc(:)

  contains

  subroutine tconv1_init1 ( nm_in, nbc_in)
    integer ::  nm_in, nbc_in

    nm=nm_in
    nbc=nbc_in
    nd=nm+nbc-1
  end subroutine
  
  subroutine tconv1_init2 ( bc_in)
    real, dimension(nbc):: bc_in
    allocate(bc(nbc))
    bc=bc_in
  end subroutine

    
  function tconv1_lop( adj, add, m, d) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: d
    real,dimension(:)  :: m
    call tconv1_lop2(adj,add,m,d)
    stat=0

  end function 

  subroutine tconv1_lop2(adj,add,m,d)
    logical,intent(in) :: adj,add 
    real, dimension (nd)  :: d
    real, dimension (nm):: m
    integer:: ib, im, id
    if(adj) then
       if(.not. add) m = 0
!       m=m+d
    else
       if(.not. add) d = 0
!       d=d+m
    end if 

    do ib=1,nbc
      do im=1, nm
        id=im+ib-1
        if (adj) then
          m(im) = m(im)+bc(ib)*d(id) 
        else
          d(id) = d(id)+bc(ib)*m(im) 
        end if
      end do
    end do

  end subroutine

end module 
