module wemva_only_mod

  use sep
  use fbi_mod
!  use fbi_energ_mod
 
  implicit none

  real, private                            :: lambda
  real, dimension(:), allocatable, private :: model1, model2, data1, data2

  contains

  subroutine wemva_only_init(nd, nm)
    integer    :: nd, nm
    logical    :: wemva_in
    allocate(model1(nm/2)) 
    allocate(model2(nm/2)) 
    allocate(data1(nd/2)) 
    allocate(data2(nd/2)) 
  end subroutine

  function wemva_only(adj, add, model, data) result(stat)
    integer                      :: stat 
    logical, intent(in)          :: adj, add 
    real, dimension(:)           :: model, data
    call wemva_only2(adj, add, model, data)
    stat=0
  end function

  subroutine wemva_only2(adj, add, model, data)
    logical, intent(in)          :: adj, add
    real, dimension(:)           :: model
    real, dimension(:)           :: data
    if(adj) then
      if(.not. add) model = 0.
      call W_lop2(.true., .false., model2, data)
      model=model+model2
    else
      if(.not. add) data = 0.
      call W_lop2(.false., .false., model, data2)
      data=data+data2
    end if

  end subroutine

end module
